<script setup lang="ts">
import { reactive, onMounted, ref, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { Form, message, Modal } from 'ant-design-vue/lib';
import { SizeType } from 'ant-design-vue/lib/config-provider';
import { MenuInfo } from 'ant-design-vue/lib/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/lib/table';
import { parseDateToStr } from '@/utils/date-utils';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import useI18n from '@/hooks/useI18n';
import useDictStore from '@/store/modules/dict';
import useNeInfoStore from '@/store/modules/neinfo';
import {
  addPerfThre,
  delPerfThre,
  getPerfThre,
  listPerfThreshold,
  updatePerfThre,
  threStop,
  threRun,
} from '@/api/perfManage/perfThreshold';
const { getDict } = useDictStore();
const { t, currentLocale } = useI18n();

/**字典数据 */
let dict: {
  /**原始严重程度 */
  activeAlarmSeverity: DictType[];
} = reactive({
  activeAlarmSeverity: [],
});

/**查询参数 */
let queryParams = reactive({
  /**网元类型 */
  neType: '',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    neType: '',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: true,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('common.rowId'),
    dataIndex: 'id',
    align: 'center',
  },
  {
    title: t('views.perfManage.taskManage.neType'),
    dataIndex: 'neType',
    align: 'center',
  },
  {
    title: t('views.perfManage.perfThreshold.staticSet'),
    dataIndex: 'kpiSet',
    align: 'center',
  },
  {
    title: t('views.perfManage.perfThreshold.threValue'),
    dataIndex: 'threshold',
    align: 'center',
  },
  {
    title: t('views.perfManage.perfThreshold.alarmLevel'),
    dataIndex: 'origSeverity',
    align: 'center',
  },
  {
    title: t('views.perfManage.perfThreshold.status'),
    dataIndex: 'status',
    key: 'status',
    align: 'center',
  },
  {
    title: t('common.operate'),
    key: 'id',
    align: 'center',
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**
 * 性能门限删除
 * @param row 记录编号ID
 */
function fnRecordDelete(row: Record<string, any>) {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.perfManage.perfThreshold.delThreTip', { num: row.id }),
    onOk() {
      const key = 'delThreshold';
      message.loading({ content: t('common.loading'), key });
      delPerfThre(row).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('views.perfManage.perfThreshold.delThre', {
              num: row.id,
            }),
            key,
            duration: 2,
          });
          fnGetList();
        } else {
          message.error({
            content: `${res.msg}`,
            key: key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**查询信息列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  listPerfThreshold(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }
      tablePagination.total = res.total;
      tableState.data = res.rows;
      if (tablePagination.total <=(queryParams.pageNum - 1) * tablePagination.pageSize &&queryParams.pageNum !== 1) {
        tableState.loading = false;
        fnGetList(queryParams.pageNum - 1);
      }
    }
    tableState.loading = false;
  });
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**详情框是否显示 */
  visibleByView: boolean;
  /**新增框或修改框是否显示 */
  visibleByEdit: boolean;
  /**标题 */
  title: string;
  /**网元类型设备对象 */
  neType: string[];
  /**网元类型性能测量集 */
  neTypPerformance: Record<string, any>[];
  /**表单数据 */
  from: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  visibleByView: false,
  visibleByEdit: false,
  title: '',
  neType: [],
  neTypPerformance: [],
  from: {
    id: '',
    neType: '',
    origSeverity: '',
    kpiSet: '',
    threshold: '',
  },
  confirmLoading: false,
});

/**对话框内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    neType: [
      {
        required: true,
        message: t('views.traceManage.task.neTypePlease'),
      },
    ],

    kpiSet: [
      {
        required: true,
        message: t('views.perfManage.taskManage.performanceSelect'),
      },
    ],
  })
);

/**性能测量数据集选择初始 */
function fnSelectPerformanceInit(value: any) {
  //console.logg(currentLocale.value); //当前语言
  const performance = useNeInfoStore().perMeasurementList.filter(
    i => i.neType === value
  );
  //进行分组选择
  const groupedData = performance.reduce((groups: any, item: any) => {
    const { kpiCode, ...rest } = item;
    if (!groups[kpiCode]) {
      groups[kpiCode] = [];
    }
    groups[kpiCode].push(rest);
    return groups;
  }, {});

  //渲染出性能测量集的选择项
  modalState.neTypPerformance = Object.keys(groupedData).map(kpiCode => {
    return {
      label: kpiCode,
      options: groupedData[kpiCode].map((item: any) => {
        return {
          value: item.kpiId,
          label:
            currentLocale.value === 'zh_CN'
              ? JSON.parse(item.titleJson).cn
              : JSON.parse(item.titleJson).en,
          kpiCode: kpiCode,
        };
      }),
    };
  });
}

/**
 * 对话框弹出显示为 新增或者修改
 * @param noticeId 网元id, 不传为新增
 */
function fnModalVisibleByEdit(id?: string) {
  if (!id) {
    modalStateFrom.resetFields();
    modalState.title = t('views.perfManage.perfThreshold.addThre');
    modalState.visibleByEdit = true;
  } else {
    if (modalState.confirmLoading) return;
    const hide = message.loading(t('common.loading'), 0);
    modalState.confirmLoading = true;
    getPerfThre(id).then(res => {
      modalState.confirmLoading = false;
      hide();
      if (res.code === RESULT_CODE_SUCCESS && res.data) {
        modalState.from = Object.assign(modalState.from, res.data);
        modalState.title = t('views.perfManage.perfThreshold.editThre');
        modalState.visibleByEdit = true;
      } else {
        message.error(t('views.perfManage.perfThreshold.errorThreInfo'), 3);
      }
    });
  }
}

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  //console.log(modalState.from);
  modalStateFrom
    .validate()
    .then(e => {
      const from = toRaw(modalState.from);
      modalState.confirmLoading = true;
      const perfTask = from.id ? updatePerfThre(from) : addPerfThre(from);
      const hide = message.loading(t('common.loading'), 0);
      perfTask
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            modalState.visibleByEdit = false;
            modalStateFrom.resetFields();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
          fnGetList();
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.visibleByEdit = false;
  modalState.confirmLoading = false;
  modalStateFrom.resetFields();
  modalState.neType = [];
}

/**
 * 激活性能门限
 * @param row 网元编号ID
 */
function fnRecordRun(row: Record<string, any>) {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.perfManage.perfThreshold.letupSure', { id: row.id }),
    onOk() {
      const key = 'taskRun';
      message.loading({ content: t('common.loading'), key });
      threRun(row).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('common.msgSuccess', {
              msg: t('views.configManage.softwareManage.runBtn'),
            }),
            key,
            duration: 2,
          });
          fnGetList();
        } else {
          message.error({
            content: `${res.msg}`,
            key: key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**
 * 挂起性能门限
 * @param row 网元编号ID
 */
function fnRecordStop(row: Record<string, any>) {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.perfManage.perfThreshold.stopSure', { id: row.id }),
    onOk() {
      const key = 'taskStop';
      message.loading({ content: t('common.loading'), key });
      threStop(row).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('common.msgSuccess', {
              msg: t('views.perfManage.taskManage.stopTask'),
            }),
            key,
            duration: 2,
          });
          fnGetList();
        } else {
          message.error({
            content: `${res.msg}`,
            key: key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**
 * 记录多项选择
 */
function fnTaskModalVisible(type: string | number, row: Record<string, any>) {
  if (type === 'run') {
    if (row.status === 'Active') {
      var key = 'Active';
      message.error({
        content: t('views.perfManage.perfThreshold.letUpWarning'),
        key: key,
        duration: 2,
      });
      return false;
    }
    fnRecordRun(row);
  }

  if (type === 'stop') {
    if (row.status === 'Inactive') {
      var key = 'stop';
      message.error({
        content: t('views.perfManage.perfThreshold.stopWarning'),
        key: key,
        duration: 2,
      });
      return false;
    }
    fnRecordStop(row);
  }
}

onMounted(() => {
  // 初始字典数据
  Promise.allSettled([getDict('active_alarm_severity')]).then(resArr => {
    if (resArr[0].status === 'fulfilled') {
      dict.activeAlarmSeverity = resArr[0].value;
    }
  });

  Promise.allSettled([
    // 获取网元网元列表
    useNeInfoStore().fnNelist(),
    // 获取性能测量集列表
    useNeInfoStore().fnNeTaskPerformance(),
  ]).finally(() => {
    // 获取列表数据
    fnGetList();
  });
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.traceManage.task.neType')"
              name="neType "
            >
              <a-auto-complete
                v-model:value="queryParams.neType"
                :options="useNeInfoStore().getNeSelectOtions"
                allow-clear
                :placeholder="t('views.traceManage.task.neTypePlease')"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-button type="primary" @click.prevent="fnModalVisibleByEdit()">
          <template #icon><PlusOutlined /></template>
          {{ t('common.addText') }}
        </a-button>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown trigger="click" placement="bottomRight">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">{{
                    t('common.size.default')
                  }}</a-menu-item>
                  <a-menu-item key="middle">{{
                    t('common.size.middle')
                  }}</a-menu-item>
                  <a-menu-item key="small">{{
                    t('common.size.small')
                  }}</a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="id"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: true }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'id'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{ t('common.editText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByEdit(record.id)"
                  :disabled="record.status !== 'Inactive'"
                >
                  <template #icon><FormOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.deleteText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordDelete(record)"
                  :disabled="record.status !== 'Inactive'"
                >
                  <template #icon><DeleteOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.moreText') }}</template>
                <a-dropdown
                  placement="bottomRight"
                  :trigger="['hover', 'click']"
                >
                  <a-button type="link">
                    <template #icon><EllipsisOutlined /> </template>
                  </a-button>
                  <template #overlay>
                    <a-menu
                      @click="({ key }:any) => fnTaskModalVisible(key, record)"
                    >
                      <a-menu-item key="run">
                        <ThunderboltOutlined />
                        {{ t('views.configManage.softwareManage.runBtn') }}
                      </a-menu-item>
                      <a-menu-item key="stop">
                        <UndoOutlined />
                        {{ t('views.perfManage.taskManage.stopTask') }}
                      </a-menu-item>
                    </a-menu>
                  </template>
                </a-dropdown>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 新增框或修改框 -->
    <a-modal
      width="800px"
      :keyboard="false"
      :mask-closable="false"
      :visible="modalState.visibleByEdit"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    >
      <a-form name="modalStateFrom" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.traceManage.task.neType')"
              name="neType"
              v-bind="modalStateFrom.validateInfos.neType"
            >
              <a-select
                v-model:value="modalState.from.neType"
                :options="useNeInfoStore().getNeSelectOtions"
                @change="fnSelectPerformanceInit"
                :allow-clear="false"
                :placeholder="t('views.traceManage.task.neTypePlease')"
              >
              </a-select>
            </a-form-item>
          </a-col>
        </a-row>

        <a-form-item
          :label="t('views.perfManage.taskManage.performanceList')"
          name="kpiSet"
          v-show="modalState.from.neType"
          v-bind="modalStateFrom.validateInfos.kpiSet"
        >
          <a-select
            placeholder="Please select"
            v-model:value="modalState.from.kpiSet"
            :options="modalState.neTypPerformance"
          >
          </a-select>
        </a-form-item>

        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.perfManage.perfThreshold.thresholdValue')"
              name="threshold"
              v-bind="modalStateFrom.validateInfos.threshold"
            >
              <a-input v-model:value="modalState.from.threshold" allow-clear>
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.faultManage.activeAlarm.alarmType')"
              name="origSeverity"
            >
              <a-select
                v-model:value="modalState.from.origSeverity"
                style="width: 100%"
                :options="dict.activeAlarmSeverity"
              >
              </a-select>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-modal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
